<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - FOR Loops</TITLE>
<link href="builder_19.html" rel=Next>
<link href="builder_17.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_17.html">previous</A>, <A HREF="builder_19.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC46" HREF="builder_toc.html#TOC46">FOR Loops</A></H2>
<P>
<A NAME="IDX118"></A>
<A NAME="IDX119"></A>
A simple FOR loop corresponding to the <CODE>for</CODE> structure in C and the
<CODE>do</CODE> structure in FORTRAN can be constructed using the builder.
The builder's <CODE>FOR()</CODE> function gets translated to a SUIF FOR
tree node.

<PRE>
        for(int i=0; i&#60;=10; i++)
            ....

can be generated using builder by:

        block i(block::new_sym(cst_int, i));
        block code(block::FOR(i, block(0), block(10), block(...)));
</PRE>

<P>
<A NAME="IDX120"></A>
The fields of the builder <CODE>FOR()</CODE> function are
<DL COMPACT>

<DT>
<DD>
The index variable.

<DT>
<DD>
The lower bound.

<DT>
<DD>
Optional: The loop test.  Any builder enum of a test operator can be
used. The default is <CODE>bop_leq</CODE> (<EM>&#60;=</EM>).

<DT>
<DD>
The upper bound.

<DT>
<DD>
Optional: The step size. The default is 1.

<DT>
<DD>
The body of the loop.
</DL>
<P>
 

</P>
<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_17.html">previous</A>, <A HREF="builder_19.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
